import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;


public class Main
{
    public static void mainListComparable() {
        PotentialHusband honza = new PotentialHusband("Honza", 155, 40000);
        PotentialHusband franta = new PotentialHusband("Franta", 130, 40000);
        PotentialHusband helmut = new PotentialHusband("Helmut", 150, 65000);
        PotentialHusband albert = new PotentialHusband("Albert", 189, 9500);
        
        List<PotentialHusband> husbandsList = new ArrayList<>();
        husbandsList.add(honza);
        husbandsList.add(franta);
        husbandsList.add(helmut);
        husbandsList.add(albert);
        
        //postupne odkomentovat vzdy jednu z moznosti a sledovat poradie vo vypise
        //(ak by sme ich pustili za sebou, mohlo by to davat nie uplne jasne vysledky,
        // pretoze kazdy dalsi "sort" by radil uz kolekciu zoradenu z predchadzajuceho volania. 
        // takze ak si vzdy odkomentujete len jedno, uvidite asi najlepsie, ako to je zoradene
        // (v porovnani s tym, v akom poradi sme jednotlivych potencialnych manzelov pridavali).)
        
        /*
        System.out.println("Husbands: " + husbandsList.toString());
        
        System.out.println("Maximum (= last), natural ordering: " + Collections.max(husbandsList));
        Collections.sort(husbandsList);
        System.out.println("Sorted (natural ordering): " + husbandsList);*/
        
        /*
        Comparator<PotentialHusband> iQComparator = new HusbandsByIQComparator();
        Collections.sort(husbandsList, iQComparator);
        System.out.println("Sorted by IQ: " + husbandsList);*/
        
        /*Collections.sort(husbandsList, new HusbandsBySalaryComparator());
        System.out.println("Sorted by salary: " + husbandsList);*/
        
        /*Collections.sort(husbandsList, new HusbandsOverallComparator());
        System.out.println("Sorted from the least appealing to the most: " + husbandsList);*/
    }
    
    public static void mainSortedSet() {
        PotentialHusband honza = new PotentialHusband("Honza", 155, 40000);
        PotentialHusband franta = new PotentialHusband("Franta", 130, 40000);
        PotentialHusband helmut = new PotentialHusband("Helmut", 150, 65000);
        PotentialHusband albert = new PotentialHusband("Albert", 189, 9500);
        
        Set<PotentialHusband> husbandsSet = new TreeSet<>(); //radi podla prirodzeneho usporiadania (definovane metodou compareTo)
        husbandsSet.add(honza);
        husbandsSet.add(franta);
        husbandsSet.add(helmut);
        husbandsSet.add(albert);
        
        System.out.println("Husbands: " + husbandsSet);
    }
    
    public static void mainSortedSetWithComparator() {
        PotentialHusband honza = new PotentialHusband("Honza", 155, 40000);
        PotentialHusband franta = new PotentialHusband("Franta", 130, 40000);
        PotentialHusband helmut = new PotentialHusband("Helmut", 150, 65000);
        PotentialHusband albert = new PotentialHusband("Albert", 189, 9500);
        
        Set<PotentialHusband> husbandsSet = new TreeSet<>(new HusbandsByIQComparator()); //radi podla komparatora
        husbandsSet.add(honza);
        husbandsSet.add(franta);
        husbandsSet.add(helmut);
        husbandsSet.add(albert);
        
        System.out.println("Husbands: " + husbandsSet);
    }
}
